*( COMMON.CMD--Ad Hoc Selection for Browsing.)
SET MESSAGES OFF ; SET ERR MESSAGES OFF
*( Set BELL OFF so when checking for common column values,)
*( it won't beep if it doesn't find a match. It doesn't)
*( require a common column unless combining data from two tables.)
SET BELL OFF
CLS
*( Display a menu of databases in the current directory. To include this)
*( command file as a block in an application by using the Macro option)
*( omit this section so the program uses the currently open database.)
CHOOSE vdatab FROM #DATABASES
IF vdatab IS NULL THEN
  QUIT
ENDIF
CONNECT .vdatab
*( The LABEL identifies where control will return after a pick, so you can)
*( choose again without reconnecting to the database.)
LABEL pickagin
CLS
WRITE 'Choose the primary table. [Esc] to exit.' AT 23 10
*( Display a menu of the tables in the database.)
CHOOSE vtable1 FROM #TABLES
*( Provide an "out," so if you don't want to continue selecting, you can)
*( press [Esc] to leave the command file.)
IF vtable1 = '[Esc]' THEN
  CLEAR VAR vchkcom, vcols1, vcols2, vcommon, vdatab, vsecond, +
    vshort1, vshort2, vsort, vtable1, vtable2
  SET MESSAGES ON
  SET ERROR MESSAGES ON
  SET BELL ON ; CLS
  RETURN
ENDIF
*( Use SET VAR to ensure that you have a menu name for the table.)
*( You provided a menu file for each table using the first eight)
*( characters of the table name as the menu name. SGET moves)
*( the first eight characters of the table name stored in VTABLE1 into)
*( the variable VSHORT1.)
SET VAR vshort1 = (SGET(.vtable1,8,1))
*( Display an explanation and a list of columns from the table selected)
*( earlier, so you can choose the columns from the first table. Notice the)
*( CASCADE RIGHT option to  "tile" menus on the screen in the same)
*( way that R:BASE 3.1 does with its own menus.)
WRITE 'Choose the columns you want to display. F2 to continue.' +
  AT 23, 10
CHOOSE vcols1 FROM &vshort1 CASCADE RIGHT
*( Use SET VAR to check COMMON table to determine if a second table)
*( selection is appropriate. It does this by moving the table name into)
*( the variable VCHKCOM. If the table name exists in COMMON, then)
*( you know that at least one other table in the database has a column)
*( in common with the first table. If VCHKCOM is null, the table doesn't)
*( exist in COMMON, so command file sets variable VSECOND to N)
*( and doesn't ask for a second table--it skips the FILLIN.)
SET VAR vchkcom = comtable IN common WHERE comtable=.vtable1
IF vchkcom IS NULL THEN
   SET VAR vsecond = 'N'
   GOTO onetab
ENDIF
*( Initialize VSECOND to Y to make a second table request the default.)
*( Note that FILLIN now has an EDIT clause so you can edit the current)
*( contents of the FILLIN variable.)
SET VAR vsecond = 'Y'
CLS FROM 23 TO 23
FILLIN vsecond=1 USING 'Do you want to combine tables? ' +
  AT 23 10 EDIT
LABEL onetab
*( These commands execute if you do want a second table.)
IF vsecond EQ 'Y' THEN
  CLS FROM 23 TO 23
  WRITE 'Choose a combining column.' AT 23 10
  CHOOSE vcommon FROM #VALUES FOR DISTINCT comcolumn +
    FROM common WHERE comtable = .vtable1 CASCADE RIGHT
  CLS
  WRITE 'Choose the secondary table.' AT 23 10
  CHOOSE vtable2 FROM #VALUES FOR DISTINCT comtable +
    FROM common WHERE comcolumn = .vcommon
  SET VAR vshort2 = (SGET(.vtable2,8,1))
  CLS FROM 23 TO 23
  WRITE 'Choose the columns you want to display. F2 to execute. ' +
    AT 23 10
  CHOOSE vcols2 FROM &vshort2 CASCADE RIGHT
  BROWSE DISTINCT &vcols1, &vcols2 FROM &vtable1, &vtable2 +
     WHERE &vcommon = &vcommon ORDER BY &vcommon
ELSE  *( These commands execute if you don't want a second table.)
  CLS FROM 23 TO 23
  WRITE 'Choose one or more columns to sort by (ascending).' AT 23 10
  CHOOSE vsort FROM &vshort1 CASCADE RIGHT
  BROWSE DISTINCT &vcols1 FROM &vtable1 ORDER BY &vsort
ENDIF
*( When you exit from the tabular edit display, clear the variables and)
*( pass control to the top of the command file at the PICKAGIN label.)
CLEAR VAR vchkcom, vcols1, vcols2, vcommon, vdatab, vsecond, +
  vshort1, vshort2, vsort, vtable1, vtable2
GOTO pickagin


