*( TIMER.CMD--Set run date and time.)
SET BELL OFF ; SET INSERT OFF
SET MESSAGES OFF
SET ERROR MESSAGES OFF
SET ERROR VAR verr
LABEL begin
SET DATE FORMAT MM/DD/YY
SET TIME FORMAT HH:MM
SET VAR vdttext TEXT = ('Currently:' +
  & CTXT(.#DATE) & CTXT(.#TIME)), +
  vfore TEXT = 'white', vback TEXT = 'blue'
SET COLOR .vfore ON .vback ; CLS
DISPLAY collect.snp AT 8, 12
WRITE '        ' AT 11 22 black ON gray
WRITE '     ' AT 11 39 black ON gray
WRITE 'mm/dd/yy' AT 10 22 white ON cyan
WRITE 'hh:mm' AT 10 39 white ON cyan
WRITE .vdttext AT 12 16 blue ON cyan
*( Set date.)
LABEL expdt1
CLEAR VAR vdte
SET VAR vdte DATE
FILLIN vdte=8 USING '' +
  AT 11 22 black ON gray
IF verr <> 0 THEN
  RUN error.cmd USING +
    'not a valid date      MM/DD/YY'
  WRITE '        ' AT 11 22 black ON gray
  GOTO expdt1
ENDIF
IF vdte IS NULL THEN
  GOTO endexp
ENDIF
IF vdte < .#DATE THEN
  RUN error.cmd USING +
    'That date has passed.'
  GOTO expdt1
ENDIF
*( Set time.)
LABEL expdt2
CLEAR VAR vtm2
SET VAR vtm2 TIME
SET TIME SEQ HHMM
FILLIN vtm2=5 USING '' AT 11 39 +
  black ON gray
IF verr <> 0 THEN
  RUN error.cmd USING +
    'not a valid time HH:MM'
  WRITE '     ' AT 11 39 black ON gray
  GOTO expdt2
ENDIF
IF vtm2 IS NULL THEN
  GOTO expdt1
ENDIF
IF vdte <= .#DATE AND vtm2 < .#TIME THEN
  RUN error.cmd USING +
    'That time has passed.'
  WRITE '     ' AT 11 39 black ON gray
  GOTO expdt2
ENDIF
LABEL timeron
NEW
SET DATE FORMAT MM/DD/YY
SET TIME FORMAT HH:MM
DISPLAY display.snp AT 8, 12
WRITE .vdte AT 10 24 black ON gray
WRITE .vtm2 AT 10 39 black ON gray
WRITE 'Press [F2] to Start timer.' +
  AT 12 18 white ON cyan
WRITE 'Press [F6] to change the setting, +
or [Esc] to cancel.' AT 15 4 white ON cyan
LABEL ft
FILLIN vstr=0 USING '' AT 12 60
IF vstr IS NULL THEN
  GOTO ft
ELSE
  IF vstr = '[Esc]' THEN
    GOTO endexp
  ELSE
    IF vstr = '[F6]' THEN
      GOTO begin
    ENDIF
    IF vstr <> '[F2]'  THEN
      GOTO ft
    ENDIF
  ENDIF
ENDIF
IF #DATE > .vdte THEN  *( [F2] pressed.)
  GOTO toolate
ENDIF
SET VAR vtimer INT = 251, vwhms INT = 1
SET ESCAPE OFF
WHILE #DATE < .vdte THEN  *( Date loop.)
  SET COLOR gray ON black
  SET DATE FORMAT 'WWW-MMM-DD'
  SET VAR vset = +
    ('Date set for -' & CTXT(.vdte) +
    & 'Current date is -' & CTXT(#DATE))
  WRITE .vset AT .vwhms 14
  IF vtimer > 250 THEN
    IF vwhms > 22 THEN
      SET VAR vwhms = 1, vtimer = 0
    ELSE
      SET VAR vwhms=(.vwhms + 1), +
        vtimer = 0
    ENDIF
    CLS
    WRITE 'Timer activated, press [F5] to +
change or [Esc] to cancel.' AT .vwhms 5
    SET VAR vwhms = (.vwhms + 1)
  ENDIF
  SET VAR vtimer = (.vtimer + 1), +
    vchkkey = (CHKKEY(0))
  IF vchkkey = 1 THEN
    SET VAR vgetkey = (GETKEY(0))
    IF vgetkey = '[Esc]' THEN
      GOTO endexp
    ENDIF
    IF vgetkey = '[F5]' THEN
      SET COLOR .vfore ON .vback
      GOTO timeron
    ENDIF
  ENDIF
ENDWHILE
IF #TIME > .vtm2 THEN
  *( By the time you pressed [F2],)
  *( the date or time set had passed.)
  LABEL toolate
  SET VAR vdttext = +
    ('Current date' & CTXT(.#DATE) +
    & 'Current time - ' + CTXT(.#TIME))
  WRITE .vdttext AT 12 17 black ON gray
  RUN error.cmd USING +
    'Date is past enter date & time again'
  GOTO begin
ENDIF
WHILE #TIME < .vtm2 THEN  *( Time loop.)
  SET COLOR gray ON black
  SET TIME FORMAT HH:MM:SS
  SET VAR vset = ('Timer set for' +
    & CTXT(.vtm2) & 'Current time is' +
    & CTXT(#TIME))
  WRITE .vset AT .vwhms 14
  IF vtimer > 250 THEN
    IF vwhms > 22 THEN
      SET VAR vwhms = 1, vtimer = 0
    ELSE
      SET VAR vwhms = (.vwhms + 1), +
        vtimer = 0
    ENDIF
    CLS
    WRITE 'Timer activated. +
Press [F5] to change the settings, +
or [Esc] to cancel.' AT .vwhms 5
    SET VAR vwhms = (.vwhms + 1)
  ENDIF
  SET VAR vtimer = (.vtimer + 1), +
    vchkkey = (CHKKEY(0))
  IF vchkkey = 1 THEN
    SET VAR vgetkey = (GETKEY(0))
    IF vgetkey = '[Esc]' THEN
      GOTO endexp
    ENDIF
    IF vgetkey = '[F5]' THEN
      SET COLOR .vfore ON .vback
      GOTO timeron
    ENDIF
  ENDIF
ENDWHILE
BEEP ; CLS  *( Time up! Alarm goes off.)
SET COLOR .vfore ON .vback
*( Put RUN command here to run program.)
RUN your.cmd  *( program. to execute.)
LABEL endexp
SET COLOR .vfore ON .vback
CLEAR VAR vtm2, vdte, vchkkey, vgetkey, +
  vtimer, vwhms, vdttext, vtmtext, vfore, +
  vback, vset, vstr, verr
*( Reset the environment.)
SET TIME FORMAT HH:MM:SS
SET TIME SEQ HHMMSS
SET DATE FORMAT MM/DD/YYYY
SET MESSAGES ON
SET ERROR MESSAGES ON
SET BELL ON ; SET INSERT ON
SET ESCAPE ON
RETURN

